diff --git a/src/detection-plugins/sp_sctp_cause_code.c b/src/detection-plugins/sp_sctp_cause_code.c
new file mode 100644
index 0000000..9d7a5ed
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_cause_code.c
@@ -0,0 +1,324 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <sys/types.h>
+#include <stdlib.h>
+#include <ctype.h>
+
+#include "sf_types.h"
+#include "rules.h"
+#include "treenodes.h"
+#include "decode.h"
+#include "plugbase.h"
+#include "parser.h"
+#include "util.h"
+#include "snort_debug.h"
+#include "plugin_enum.h"
+#include "sp_sctp_cause_code.h"
+#include "sp_sctp_chunk_type.h"
+
+#include "snort.h"
+#include "profiler.h"
+#ifdef PERF_PROFILING
+PreprocStats sctpCauseCodePerfStats;
+extern PreprocStats ruleOTNEvalPerfStats;
+#endif
+
+#include "sfhashfcn.h"
+#include "detection_options.h"
+
+
+/**
+ * SctpCauseCodeHash - Hash function for sctp_cause_code.
+ * @data: pointer to SctpCauseCodeData.
+ *
+ * Returns a uint32_t representing the hash.
+ */
+uint32_t SctpCauseCodeHash(void *data)
+{
+    uint32_t a, b, c;
+    SctpCauseCodeData *sccd = (SctpCauseCodeData *)data;
+
+    a = sccd->cause_code;
+    b = RULE_OPTION_TYPE_SCTP_CAUSE_CODE;
+    c = 0;
+    final(a, b, c);
+
+    return c;
+}
+
+/**
+ * SctpCauseCodeCompare - Comparator function for sctp_cause_code.
+ * @l: pointer to SctpCauseCodeData (left side).
+ * @r: pointer to SctpCauseCodeData (right side).
+ *
+ * Returns the comparison result of the two data structures.
+ */
+int SctpCauseCodeCompare(void *l, void *r)
+{
+    SctpCauseCodeData *left = (SctpCauseCodeData *)l;
+    SctpCauseCodeData *right = (SctpCauseCodeData *)r;
+
+    if (!left)
+        return (!right ? DETECTION_OPTION_EQUAL : 
+                         DETECTION_OPTION_NOT_EQUAL);
+    
+    if (!right)
+        return (!left ? DETECTION_OPTION_EQUAL : 
+                        DETECTION_OPTION_NOT_EQUAL);
+
+    if (left->cause_code != right->cause_code)
+        return DETECTION_OPTION_NOT_EQUAL;
+
+    return DETECTION_OPTION_EQUAL;
+}
+
+/**
+ * SctpCauseCodeSetup - Setup function for sctp_cause_code.
+ *
+ * Links the 'sctp_cause_code' keyword to its initialization function.
+ * Returns void.
+ */
+void SctpCauseCodeSetup(void)
+{
+    /* Map the keyword to an initialization/processing function */
+    RegisterRuleOption("sctp_cause_code", SctpCauseCodeInit, NULL, OPT_TYPE_DETECTION, NULL);
+    
+#ifdef PERF_PROFILING
+    RegisterPreprocessorProfile("sctp_cause_code", &sctpCauseCodePerfStats, 3, &ruleOTNEvalPerfStats);
+#endif
+
+    DEBUG_WRAP(DebugMessage(DEBUG_PLUGIN,"Plugin: SctpCauseCode Initialized\n"););
+}
+
+/**
+ * SctpCauseCodeInit - Initialization function for sctp_cause_code.
+ * @data: pointer to SctpCauseCodeData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ * @protocol: integer value representing the transport-layer protocol.
+ *
+ * Attaches the rule option data to the appropriate data structure and links
+ * in the evaluator function to the function pointer list.  Returns void.
+ */
+void SctpCauseCodeInit(char *data, OptTreeNode *otn, int protocol)
+{
+    OptFpList *fpl;
+    SctpCauseCodeData *sccd;
+    void *sccd_dup;
+
+    /* This keyword only applies to the SCTP Protocol. */
+    if (protocol != IPPROTO_SCTP)
+        FatalError("Error at %s:%d: 'sctp_cause_code' can only be used with "
+                   "the SCTP protocol.\n", file_name, file_line);
+
+    /* This keyword requires 'sctp_chunk_type' to be used first. */
+    if (otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE] == NULL)
+        FatalError("%s(%d): 'sctp_chunk_type' must be used before "
+                   "'sctp_cause_code'.", file_name, file_line);
+
+    /* Check for multiple uses of this keyword in a rule. */
+    if (otn->ds_list[PLUGIN_SCTP_CAUSE_CODE])
+        FatalError("%s(%d): 'sctp_cause_code' may only be used once per "
+                   "rule.\n", file_name, file_line);
+
+    /* Allocate the data structure and attach it to the otn->ds_list. */
+    otn->ds_list[PLUGIN_SCTP_CAUSE_CODE] = (SctpCauseCodeData *)
+            SnortAlloc(sizeof(SctpCauseCodeData));
+
+    /* Parse the keyword's parameters and configure the data structure. */
+    SctpCauseCodeParse(data, otn);
+    sccd = otn->ds_list[PLUGIN_SCTP_CAUSE_CODE];
+
+    /* Check for a duplicate entry in the otn. */
+    if (add_detection_option(RULE_OPTION_TYPE_SCTP_CAUSE_CODE,
+                             (void *)sccd, &sccd_dup) == DETECTION_OPTION_EQUAL)
+    {
+        otn->ds_list[PLUGIN_SCTP_CAUSE_CODE] = (SctpCauseCodeData *)sccd_dup;
+        free(sccd);
+    }
+
+    /*
+     * Finally, attach the option's detection function to the rule's detection
+     * function pointer list
+     */
+    fpl = AddOptFuncToList(SctpCauseCodeEval, otn);
+    fpl->type = RULE_OPTION_TYPE_SCTP_CAUSE_CODE;
+    fpl->context = otn->ds_list[PLUGIN_SCTP_CAUSE_CODE];
+}
+
+/**
+ * SctpCauseCodeParse - Parsing function for sctp_cause_code.
+ * @data: pointer to SctpCauseCodeData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ *
+ * Parses the rule option's parameter list and fills in the SctpCauseCodeData
+ * structure.  Returns void.
+ */
+void SctpCauseCodeParse(char *data, OptTreeNode *otn)
+{
+    char *end;
+    uint16_t val = 0;
+    SctpChunkTypeData *sctd;
+    SctpCauseCodeData *sccd;
+
+    /* Get both the chunk type and cause code data sets. */
+    sctd = otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE];
+    sccd = otn->ds_list[PLUGIN_SCTP_CAUSE_CODE];
+
+    if ((sctd->parse_count == 1) || (sctd->parse_count == 2))
+    {
+        if (sctd->abort || sctd->error)
+        {
+            val = strtoul(data, &end, 10);
+            if ((val >= 0) && (val <= UINT16_MAX))
+                sccd->cause_code = (uint16_t)val;
+            else
+                FatalError("Error at %s:%d: Invalid 'sctp_num_chunks' "
+                           "argument.\n", file_name, file_line);
+        }
+        else
+            FatalError("Error at %s:%d: When using 'sctp_cause_code', the "
+                       "'sctp_chunk_type' keyword can only contain 'ABORT' "
+                       "or 'ERROR'.\n", file_name, file_line);
+    }
+    else
+        FatalError("Error at %s:%d: The number of specified chunks to "
+                   "'sctp_chunk_type' exceeds the number of chunk types in "
+                   "SCTP that support cause codes.\n", file_name, file_line);
+
+    return;
+}
+
+/**
+ * SctpCauseCodeEval - Evaluation function for sctp_cause_code.
+ * @data: pointer to SctpCauseCodeData (as char *).
+ * @p: pointer to Packet structure.
+ *
+ * Evaluates the rule option against the packet pointed to by 'p'.  Returns
+ * either DETECTION_OPTION_MATCH or DETECTION_OPTION_NO_MATCH.
+ */
+int SctpCauseCodeEval(void *data, Packet *p)
+{
+    SctpCauseCodeData *sccd = (SctpCauseCodeData *)data;
+    int rval = DETECTION_OPTION_NO_MATCH;
+    PROFILE_VARS;
+
+    if(!p->sctph || !sccd)
+        return rval;
+
+    PREPROC_PROFILE_START(sctpCauseCodePerfStats);
+
+    SctpChunk *c = (SctpChunk *)p->sctph->chunks;
+    uint32_t remaining_len = p->dsize;
+
+    /*
+     * Loop through the chunks in the packet and for each DATA chunk, check
+     * check the pp_id field against the supplied value for a match.
+     */
+    while ((c != NULL) && 
+           (remaining_len != 0) && 
+           (rval == DETECTION_OPTION_NO_MATCH))
+    {
+        uint16_t chunk_length = SCTP_ADD_PADDING(ntohs(c->length));
+        uint16_t remaining_chunk_len = chunk_length;
+		SctpCause *cause = NULL;
+        remaining_len -= chunk_length;
+        
+        /*
+         * Although we have already validated which chunks we want to check
+         * via 'sctp_chunk_type', we still have to check the chunk types
+         * here because of chunk bundling.
+         */
+        switch (c->type)
+        {
+            case SCTP_ABORT_C:
+                cause = (SctpCause *)c->abort.causes;
+                remaining_chunk_len -= SCTP_ABORT_C_LEN;
+                break;
+
+            case SCTP_ERROR_C:
+                cause = (SctpCause *)c->error.causes;
+                remaining_chunk_len -= SCTP_ERROR_C_LEN;
+                break;
+
+            case SCTP_DATA_C:
+            case SCTP_INIT_C:
+            case SCTP_INIT_ACK_C:
+            case SCTP_SACK_C:
+            case SCTP_HEARTBEAT_C:
+            case SCTP_HEARTBEAT_ACK_C:
+            case SCTP_SHUTDOWN_C:
+            case SCTP_SHUTDOWN_ACK_C:
+            case SCTP_COOKIE_ECHO_C:
+            case SCTP_COOKIE_ACK_C:
+            case SCTP_ECNE_C:
+            case SCTP_CWR_C:
+            case SCTP_SHUTDOWN_COMPLETE_C:
+            case SCTP_AUTH_C:
+            case SCTP_ASCONF_ACK_C:
+            case SCTP_PKTDROP_C:
+            case SCTP_PAD_C:
+            case SCTP_FORWARD_TSN_C:
+            case SCTP_ASCONF_C:
+                break;
+
+            default:
+                DEBUG_WRAP(DebugMessage(
+                    DEBUG_PLUGIN, "Plugin (sctp_cause_code): Encountered "
+                                  "an unknown SCTP Chunk Type 0x%2x!\n",
+                                  c->type));
+                break;
+        }
+
+        /*
+         * If we encountered either an ABORT chunk or ERROR chunk, then
+         * cause_data will not be NULL and the below loop, which mimics the
+         * chunk-counting loop in src/decode.c::DecodeSCTP(), will walk the
+         * causes and look for a matching cause code.
+         *
+         * Note that ABORT can have zero or more causes and ERROR will have
+         * at least one cause.
+         */
+        while ((cause != NULL) &&
+               (remaining_chunk_len != 0) &&
+               (rval == DETECTION_OPTION_NO_MATCH))
+        {
+            uint16_t cause_len = SCTP_ADD_PADDING(ntohs(cause->length));
+            remaining_chunk_len -= cause_len;
+            
+            if (ntohs(cause->code) == sccd->cause_code)
+                rval = DETECTION_OPTION_MATCH;
+
+            remaining_chunk_len = SctpGetNextCause(c, remaining_chunk_len,
+                                                   cause_len);
+        }
+
+        remaining_len = SctpGetNextChunk(c, remaining_len, chunk_length);
+    }
+
+    /* If the test isn't successful, return DETECTION_OPTION_NO_MATCH */
+    PREPROC_PROFILE_END(sctpCauseCodePerfStats);
+    return rval;
+}
diff --git a/src/detection-plugins/sp_sctp_cause_code.h b/src/detection-plugins/sp_sctp_cause_code.h
new file mode 100644
index 0000000..46e4b38
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_cause_code.h
@@ -0,0 +1,38 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+#ifndef __SP_SCTP_CAUSE_CODE_H__
+#define __SP_SCTP_CAUSE_CODE_H__
+
+/* SctpCauseCode data structure. */
+typedef struct _SctpCauseCodeData
+{
+    uint16_t cause_code;
+} SctpCauseCodeData;
+
+/* Prototypes. */
+uint32_t SctpCauseCodeHash(void *data);
+int SctpCauseCodeCompare(void *l, void *r);
+void SctpCauseCodeSetup(void);
+void SctpCauseCodeInit(char *data, OptTreeNode *otn, int protocol);
+void SctpCauseCodeParse(char *data, OptTreeNode *otn);
+int SctpCauseCodeEval(void *data, Packet *p);
+
+#endif  /* __SP_SCTP_CAUSE_CODE_H__ */
